'use strict';

const rp = require('request-promise');
const _  = require('lodash');

function request(authenticatedEntity, opt) {
    opt = opt || {};
    const authEntityEncoded = new Buffer(JSON.stringify(authenticatedEntity)).toString('base64');
    const options = {
        resolveWithFullResponse: true,
        json: true,
        headers: {
            'X-Authenticated-Entity-Json': authEntityEncoded
        }
    };
    return rp(_.merge(options, opt))
        .catch((errorResponse) => {
            throw errorResponse.error;
        })
        .then((res) => res.body);
}

module.exports = request;